#include<bits/stdc++.h>
#define ff first
#define ss second
using namespace std;
long long n,m,i,j,k,l,p,q,r,g,h,a[1000009],ans,cnt;
vector < pair <long long, long long> > v;
map <long long ,long long> mp;
vector <long long> pa;
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(i=1; i<=n; i++)
    {
        cin >> a[i];
        mp[a[i]]++;
    }
    for(auto it=mp.begin();it!=mp.end();it++)
    {
        if (it->second>=1)
        {
            pa.push_back(it->first);
        }
    }
    sort(pa.begin(),pa.end());
    for(i=pa.size()-1; i>=0; i--)
    {
        cnt=pa[i];
        for(j=1; j<=n; j++)
        {
            if (a[j]==cnt)
            {
                reverse(a+1,a+j+1);
//                if (1==j)
//                {
//
//                }
//                else
                {
                    v.push_back({1,j});
                    for(l=1; l<=n; l++)
                    {
                        cout << a[l] << " ";
                    }
                    cout << "\n";
                }


                reverse(a+1,a+i+2);
//                if (1==i)
//                {
//
//                }
//                else
                {
                    v.push_back({1,i+1});
                    for(l=1; l<=n; l++)
                    {
                        cout << a[l] << " ";
                    }
                    cout << "\n";
                }


                ans+=j;
                ans+=n;
                break;
            }
        }
        g=0;
        for(j=2; j<=n; j++)
        {
            if (a[j]>=a[j-1])
            {

            }
            else
            {
                g=1;
            }
        }
        if (g==1)
        {

        }
        else
        {
            cout << v.size() << "\n";
            for(l=0; l<v.size(); l++)
            {
                cout << v[l].ff << " " << v[l].ss << "\n";
            }
            return 0;
        }

    }
    cout << 0;
//    for(i=1; i<=n; i++)
//    {
//        cout << a[i] << " ";
//    }
}
